import java.io.*;
import java.security.*;

public class RandomFileName {

    private SecureRandom    random;
    public RandomFileName() {

        try {
            random = SecureRandom.getInstance("SHA1PRNG");
            byte seed[] = random.generateSeed(20);
            random.setSeed(seed);
        } catch (Exception e) {
            System.err.println("RandomFileName.RandomFileName() Exception-> " + e);
            System.exit(1);
        }
    }

    public synchronized String getName() {
            byte bytes[] = new byte[20];
            random.nextBytes(bytes);
            return (toHexString(bytes));
    }

    public void byte2hex(byte b, StringBuffer buf) {
        char hexChars[] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

        int low = (b & 0x0f);
        int high = (b & 0xf0) >> 4;

        buf.append(hexChars[high]);
        buf.append(hexChars[low]);
    }

     // Converts a byte array to hex string

    public String toHexString(byte[] block) {
        StringBuffer buf = new StringBuffer();

        int len = block.length;

        for (int i = 0; i < len; i++) {
             byte2hex(block[i], buf);
        }
        return buf.toString();
    }
}
